Ext.onReady(function(){
	
	// editor for 'network_view' field in network object - combobox which allows to select some existing network view
	
	var models = [
		{title: 'Network', model :'Network'},
		{title: 'Network View', model :'NetworkView'},
		{title: 'Network Container', model: 'NetworkContainer'},
		{title: 'Dhcp Range', model: 'Range'}
	];
	
	var typeSelector = Ext.create('Ext.form.field.ComboBox', {
		renderTo:'selector',
		store: this.store = Ext.create('Ext.data.Store',{
			autoSync: false,
			fields:['title', 'model'],
			data:models
		}),
		displayField: 'title',
		valueField:'model'
	});
	
	
	var grid = null;
	
	
	var generate = function(combo, newValue, oldValue, eOpts){
		
		if (grid != null)
			grid.destroy();
			
		var model = Ext.ModelManager.getModel(newValue);
		
		var columns = generateColumns(model.getFields());
		
		grid = Ext.create('grid.simplegrid', {
			model: model,
			renderTo: 'list',
			width: columns.length * 150 + 20,
			height: 300,
			title: newValue,
			columns: columns
		});
	
	}
		
	var generateColumns = function(fields){
		var res = [];	
		Ext.each(fields, function(f){
			if (f.name != '_ref'){
				res.push({
					text: generateColumnHeader(f.name),
					dataIndex: f.name,
					width: 150
				});
			}
		});
		return res;
	};
	
	var generateColumnHeader = function(dataindex){
		var parts = dataindex.split('_');
		var header = ""
		Ext.each(parts, function(part){
			header = header + part.substr(0,1).toUpperCase() + part.substr(1, part.length - 1) + ' ';
		});
		return header;
	}
	
	typeSelector.on('change', generate);
	
});